# A short introduction to Nix

## Step by Step:

### 1. After you have installed Nix
Some of the information detailed below is based on the following material [Introduction to Nix and Nixos](https://www.youtube.com/watch?v=QKoQ1gKJY5A&list=PL-saUBvIJzOkjAw_vOac75v-x6EzNzZq-) It is a playlist with several video's, quite long. You are probably ok with the content provided below.

### 2. System requirements
Nix or Nixos depending on how you install it can use considerable computer resources. Make sure you have enough diskspace. If you are downloading cached files and not building anything you will be OK. but otherwise 16 GB of RAM and 200 GB of drive space is advised. When running Nixos in VirtualBox you will probably need more than 16GB RAM.

### 3. The Nix system concept
The basic idea of nix is to provide a consistent developement environment. For testing purposes it is important there are no small changes, or big ones between developer systems. Small changes can cause bugs and lead to needle in a haystack searches for issues. This can take considerable time and slow down developement.

### 4. How Nix solves this
Packages are stored in /nix/store. Changing configuration does not delete a package. It will only swap symbolic links around to make the desired environment, your current working environment. This will make changing configuration very fast. It can however take considerable drive space.

### 5. Three files define your whole system
Nix will provide the minimal necessary. If you need something additional, you will have to configure your environment to include it. Your configuration is defined in the `/etc/nixos/configuration.nix` file. When you define your complete environment there, you can share this file with other developers. This is all they need to setup an identical system to where you developed and tested your application. 

With the below commands you can edit your configuration and make it your current system.
```bash
sudo nano /etc/nix/configuration.nix
sudo nixos-rebuild switch
```

Additionally, you can install `home-manager`. `home-manager` is like a default setup for your development environment. It will create a configuration file to manage user-specific packages. This file is located in `~/.config/nixpkgs/home.nix`. Install `home-manager` with:
```bash
nix-shell '<home-manager>' -A install # This will add home-manager to your channels 
```

Edit and activate
```bash
home-manager edit
home-manager switch
```
In the following link, you can find packages to install, according to your needs: [https://search.nixos.org/packages](https://search.nixos.org/packages)

In the `build` folder of your application, you will find the shell.nix file (although most of it has now been moved to `flakes`). This file defines the packages and system variables needed to build your application. In an ideal situation, you could give these three files to anyone and they would be able to recreate your system with minimal effort. Activate with:
```bash
nix-shell
```

Please note: Occasionally, information on the Internet or your system may suggest installing a package as follows:

```bash
nix-env -iA 'package-name'.
```

It is advided not to do that. This command will install the package on the system but will not add it to the configuration. If you later want to share your configuration with others this package will be missing. This can then result in errors during the build process. It is better to add the package to one of the three configuration files.

### 6. Upgrading your distribution

```bash
# List current channel
sudo nix-channel --list

# Update channels this is like sudo apt-get update on Ubuntu
sudo nix-channel --update

# Removes the old nixos channel
sudo nix-channel --remove nixos
sudo nix-channel --remove home-manager

# Add a new channel this is like a 'sudo apt-get dist-upgrade' on Ubuntu
sudo nix-channel --add nixos https://nixos.org/channels/nixos-23.05 nixos
sudo nix-channel --add  https://github.com/nix-community/home-manager/archive/release-23.05.tar.gz home-manager

# Rebuild the os -> reboot to make active
sudo nixos-rebuild switch
```
If things don't work out, you can always switch back to an older generation. In NixOS, older generations are available in the `boot` menu.

### 7. An example of a basic setup

A configuration.nix file

```bash
{ config, lib, pkgs, ... }:

{
    imports = [	<nixpkgs/nixos/modules/installer/virtualbox-demo.nix>
	    	    <home-manager/nixos> ];


    # Set your time zone.
    time.timeZone = "Europe/Amsterdam";

    # List packages installed in system profile. To search, run:
    # \$ nix search wget
    environment.systemPackages = with pkgs; [
    wget
    nano
    ];

    # Add demo as a trusted user. Swap this for your user account name.
    # If your user is not trusted and you add an external repository. This can
    # fail. Your system will then default to building all packages. Resulting
    # in long build times.
    nix = {
        settings = {
        trusted-users = [ "root" "demo" ];
        };

    # Add experimental feature nix flakes
    package = pkgs.nixFlakes;
    extraOptions = lib.optionalString (config.nix.package == pkgs.nixFlakes)
        "experimental-features = nix-command flakes";
};
}
```

A home.nix file

```bash
{ config, pkgs, ... }:

{
  # Home Manager needs a bit of information about you and the
  # paths it should manage.
  home.username = "demo";
  home.homeDirectory = "/home/demo";

  # This value determines the Home Manager release that your
  # configuration is compatible with. This helps avoid breakage
  # when a new Home Manager release introduces backwards
  # incompatible changes.
  #
  # You can update Home Manager without changing this value. See
  # the Home Manager release notes for a list of state version
  # changes in each release.
  home.stateVersion = "22.11";

  # Install vscode a browser etc. If nix is installed next to ubuntu
  # You may not need to install some of the packages below.
  home.packages = with pkgs; [
    vscode
    google-chrome
    git
    git-crypt
    gnupg
    discord
  ];
  # Let Home Manager install and manage itself.
  programs.home-manager.enable = true;
}
```

A shell.nix file

```bash
{ pkgs ? import <nixpkgs> {} }:
  pkgs.mkShell {
    # nativeBuildInputs is usually what you want -- tools you need to run
    nativeBuildInputs = [ pkgs.unixtools.xxd ];

    # Export Cardano specific system variables
    shellHook = ''
      export CARDANO_NODE_SOCKET_PATH=~/cardano-config/ipc/node.socket
      export PATH=$PATH:"~/cardano-node/cardano-cli-build/bin/"
      export PATH=$PATH:"~/cardano-node/cardano-node-build/bin/"
    '';
}
```

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;
